'use strict';

exports.__esModule = true;

var _resourceProcessorBase = require('./resource-processor-base');

var _resourceProcessorBase2 = _interopRequireDefault(_resourceProcessorBase);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class ManifestProcessor extends _resourceProcessorBase2.default {
    processResource(manifest, ctx, charset, urlReplacer) {
        const lines = manifest.split('\n');

        for (let i = 0; i < lines.length; i++) {
            const line = lines[i].trim();

            if (line && line !== 'CACHE MANIFEST' && line !== 'NETWORK:' && line !== 'FALLBACK:' && line !== 'CACHE:' && line[0] !== '#' && line !== '*') {

                const isFallbackItem = line.includes(' ');

                if (isFallbackItem) {
                    const urls = line.split(' ');

                    lines[i] = urlReplacer(urls[0]) + ' ' + urlReplacer(urls[1]);
                } else lines[i] = urlReplacer(line);
            }
        }

        return lines.join('\n');
    }

    shouldProcessResource(ctx) {
        return ctx.contentInfo.isManifest;
    }
}

exports.default = new ManifestProcessor();
module.exports = exports['default'];