'use strict';

exports.__esModule = true;

exports.default = function (fn) {
    connectionResetDomain.run(fn);
};

var _domain = require('domain');

var _domain2 = _interopRequireDefault(_domain);

var _osFamily = require('os-family');

var _osFamily2 = _interopRequireDefault(_osFamily);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const connectionResetDomain = _domain2.default.create();

connectionResetDomain.on('error', err => {
    // NOTE: The nodejs throw the EPIPE error instead of the ECONNRESET error
    // when the connection is broken in some cases on MacOS and Linux
    // https://github.com/nodejs/node/blob/8b4af64f50c5e41ce0155716f294c24ccdecad03/test/parallel/test-http-destroyed-socket-write2.js
    if (err.code === 'ECONNRESET' || !_osFamily2.default.win && err.code === 'EPIPE' || _osFamily2.default.win && err.code === 'ECONNABORTED') return;

    connectionResetDomain.removeAllListeners('error');
    throw err;
});

module.exports = exports['default'];