'use strict';

exports.__esModule = true;

var _stream = require('stream');

class IncomingMessageMock extends _stream.Readable {
    constructor(init) {
        super();

        this.headers = init.headers;
        this.trailers = init.trailers;
        this.statusCode = init.statusCode;
        this._body = this._getBody(init._body);
    }

    _read() {
        this.push(this._body);
        this._body = null;
    }

    _getBody(body) {
        if (!body) return Buffer.alloc(0);else if (body instanceof Buffer) return body;

        const bodyStr = typeof body === 'object' ? JSON.stringify(body) : String(body);

        return Buffer.from(bodyStr);
    }
}
exports.default = IncomingMessageMock;
module.exports = exports['default'];